5. Longest Palindromic Substring

Description:

Given a string s, find the longest palindromic substring in s. You may assume that the maximum length of s is 1000.

Example:

Input: "babad"
Output: "bab"
Note: "aba" is also a valid answer.

Example:

Input: "cbbd"
Output: "bb"

Solutions:

First we have to know how to determine if a string is palindromic. There are 2 ways:

  1. For string s[0...n], we check if s[0] == s[n-1], s[1] == s[n-2]... until then index i and n-i-1 equals or cross. If all the equations are satisfied, s is palindromic.
  2. For string s[0...n], we check from the middle.
    If there is odd number of characters in s, we check if s[n/2-1] == s[n/2+1], s[n/2-2] == s[n/2+2]... until s[0] == s[n-1]. We do not compare s[n/2] with s[n/2] because they are definitely equal. If all the equations are satisfied, s is palindromic. For example, `s = "abcba", in this case,
i    0  1  2  3  4
s    a  b  c  b  a
n = 5, n/2 = 2

Apparently, s[1] == s[3] and s[0] == s[4] are satisfied, so "abcba" is palindromic.
If there is even number of characters in s, we check if s[n/2-1] == s[n/2], s[n/2-2] == s[n/2+1]...until s[0] == s[n-1]. For example, s = "abba", in this case,

i     0  1  2  3
s     a  b  b  a
n = 4, n/2 = 2

Likewise, s[1] == s[2] and s[0] == s[3] are satisfied, so "abba" is palindromic.

Approach 1: Find all substrings and check if it is palindromic [Time Limit Exceeded]

In this approach, we use a nested loop to get all the substrings, then we can use the first method mentioned above to check if it is plindromic.

public class Solution {
    public String longestPalindrome(String s) {
        int n = s.length();
        String maxsub = "";
        for (int i = 0; i < n; i++) {
            for (int j = n-1; j >= i; j--) { // be careful that j >= i but not j > i or it would return "" if s is "a"
                String sub = s.substring(i, j+1);
                int sublen = j-i+1, maxlen = maxsub.length();
                if (sublen <= maxlen) break;
                if (isPalindrome(sub)) {
                    maxsub = maxlen < sublen ? sub : maxsub;
                }
            }
        }
        return maxsub;
    }
    
    public boolean isPalindrome(String s) {
        int n = s.length();
        if (n == 0 || n == 1) return true;
        int i = 0;
        while (i < n-1-i) { 
            if (s.charAt(i) != s.charAt(n-1-i)) return false;
            i++;
        }
        return true;
    }
}

This approach is too slow because every time we cut out a substring. We can simply use 2 variables to indicate the start and the end of the substring, which would reduce the time cost.

Approach 2: Optimize approach 1 with 2 "indicating pointers"

As mentioned in the last part of Approach 1, two variables can be treated as pointers to indicate the start and the end of the substring. This way we do not need to calls.substring() every time entering in the loop and would save some time.

public class Solution {
    public String longestPalindrome(String s) {
        int n = s.length();
        int maxstart = 0;
        // the maxend indicates the end position of the substring, 
        // which means if maxend = i, the sub string should  contains
        // i+1 characters, namely s[0...i]
        int maxend = 0;
        for (int i = 0; i < n; i++) {
            for (int j = n-1; j >= i; j--) {
                int sublen = j-i+1, maxlen = maxend - maxstart + 1;
                if (sublen <= maxlen) break;
                if (isPalindrome(s, i, j)) {
                    if (maxlen < sublen) {
                        maxstart = i;
                        maxend = j;
                    }
                }
            }
        }
        return s.substring(maxstart, maxend+1);
    }
    
    public boolean isPalindrome(String s, int start, int end) {
        int i = start, j = end;
        while (i < j) {
            if (s.charAt(i) != s.charAt(j)) return false;
            i++;
            j--;
        }
        return true;
    }
}

Approach 3: Extend from every character to find the longest palindromic substring

The idea is simple but it uses another method to find the palindromic substring. From every character, it tries to extend from 2 sides and to see if each pair of characters are the same. Additionally, we need to extend the character in 2 ways: odd length and even length.

public class Solution {
    int lo, maxLen;
    public String longestPalindrome(String s) {
        int n = s.length();
        for (int i = 0; i < n; i++) {
            extendPalindrome(s, i, i); // odd length
            extendPalindrome(s, i, i+1); // even length
        }
        return s.substring(lo, lo+maxLen);
    }
    
    public void extendPalindrome(String s, int j, int k) {
        while (j >= 0 && k < s.length() && s.charAt(j) == s.charAt(k)) {
            j--;
            k++;
        }
        if (maxLen < k-j-1) {
            lo = j+1;
            maxLen = k-j-1;
        }
    }
}

Approach 4: Dynamic programming

dp[i][j] indicates if s[i...j] is a palindromic string. dp[i][j] is true when and only when s[i] == s[j] and s[i+1...j-1] is a palindromic string.

public class Solution {
    public String longestPalindrome(String s) {
        int n = s.length();
        int start = 0, maxlen = 0;
        boolean[][] dp = new boolean[n][n];
        for (int j = 0; j < n; j++) {
            for (int i = j; i >= 0; i--) {
                // if the window < 3 (j-i<3)
                //    if the window = 2, for example s[2,3,4], then dp[i+1][j-1]=d[2][2] is definitely true
                //    if the window = 1, for example s[3,4], then d[i+1][j-1]=d[4][3], but s[4...3] is senseless
                //    if the window = 0, for example s[0], then d[i+1][j-1]=d[0][-1], out of boudary
               // 
                dp[i][j] = (s.charAt(i) == s.charAt(j)) && (j-i < 3 || dp[i+1][j-1]);
                
                if (dp[i][j] && j-i+1 > maxlen) {
                    start = i;
                    maxlen = j-i+1;
                }
            }
        }
        return s.substring(start, start+maxlen);
    }
    
}

Reference

[1] https://discuss.leetcode.com/topic/23498/very-simple-clean-java-solution/2
[2] https://discuss.leetcode.com/topic/25500/share-my-java-solution-using-dynamic-programming

最后编辑于
©著作权归作者所有,转载或内容合作请联系作者
  • 序言:七十年代末,一起剥皮案震惊了整个滨河市,随后出现的几起案子,更是在滨河造成了极大的恐慌,老刑警刘岩,带你破解...
    沈念sama阅读 151,688评论 1 330
  • 序言:滨河连续发生了三起死亡事件,死亡现场离奇诡异,居然都是意外死亡,警方通过查阅死者的电脑和手机,发现死者居然都...
    沈念sama阅读 64,559评论 1 273
  • 文/潘晓璐 我一进店门,熙熙楼的掌柜王于贵愁眉苦脸地迎上来,“玉大人,你说我怎么就摊上这事。” “怎么了?”我有些...
    开封第一讲书人阅读 101,749评论 0 226
  • 文/不坏的土叔 我叫张陵,是天一观的道长。 经常有香客问我,道长,这世上最难降的妖魔是什么? 我笑而不...
    开封第一讲书人阅读 42,581评论 0 191
  • 正文 为了忘掉前任,我火速办了婚礼,结果婚礼上,老公的妹妹穿的比我还像新娘。我一直安慰自己,他们只是感情好,可当我...
    茶点故事阅读 50,741评论 3 271
  • 文/花漫 我一把揭开白布。 她就那样静静地躺着,像睡着了一般。 火红的嫁衣衬着肌肤如雪。 梳的纹丝不乱的头发上,一...
    开封第一讲书人阅读 39,684评论 1 192
  • 那天,我揣着相机与录音,去河边找鬼。 笑死,一个胖子当着我的面吹牛,可吹牛的内容都是我干的。 我是一名探鬼主播,决...
    沈念sama阅读 31,122评论 2 292
  • 文/苍兰香墨 我猛地睁开眼,长吁一口气:“原来是场噩梦啊……” “哼!你这毒妇竟也来了?” 一声冷哼从身侧响起,我...
    开封第一讲书人阅读 29,847评论 0 182
  • 序言:老挝万荣一对情侣失踪,失踪者是张志新(化名)和其女友刘颖,没想到半个月后,有当地人在树林里发现了一具尸体,经...
    沈念sama阅读 33,441评论 0 228
  • 正文 独居荒郊野岭守林人离奇死亡,尸身上长有42处带血的脓包…… 初始之章·张勋 以下内容为张勋视角 年9月15日...
    茶点故事阅读 29,939评论 2 232
  • 正文 我和宋清朗相恋三年,在试婚纱的时候发现自己被绿了。 大学时的朋友给我发了我未婚夫和他白月光在一起吃饭的照片。...
    茶点故事阅读 31,333评论 1 242
  • 序言:一个原本活蹦乱跳的男人离奇死亡,死状恐怖,灵堂内的尸体忽然破棺而出,到底是诈尸还是另有隐情,我是刑警宁泽,带...
    沈念sama阅读 27,783评论 2 236
  • 正文 年R本政府宣布,位于F岛的核电站,受9级特大地震影响,放射性物质发生泄漏。R本人自食恶果不足惜,却给世界环境...
    茶点故事阅读 32,275评论 3 220
  • 文/蒙蒙 一、第九天 我趴在偏房一处隐蔽的房顶上张望。 院中可真热闹,春花似锦、人声如沸。这庄子的主人今日做“春日...
    开封第一讲书人阅读 25,830评论 0 8
  • 文/苍兰香墨 我抬头看了看天上的太阳。三九已至,却和暖如春,着一层夹袄步出监牢的瞬间,已是汗流浃背。 一阵脚步声响...
    开封第一讲书人阅读 26,444评论 0 180
  • 我被黑心中介骗来泰国打工, 没想到刚下飞机就差点儿被人妖公主榨干…… 1. 我叫王不留,地道东北人。 一个月前我还...
    沈念sama阅读 34,553评论 2 249
  • 正文 我出身青楼,却偏偏与公主长得像,于是被迫代替她去往敌国和亲。 传闻我的和亲对象是个残疾皇子,可洞房花烛夜当晚...
    茶点故事阅读 34,618评论 2 249

推荐阅读更多精彩内容

  • 有时候,莫名的心情不好,不想和任何人说话,只想一个人静静的发呆。 有时候,突然觉得心情烦躁,看什么都觉得不舒服,心...
    茗艺堂阅读 196评论 0 0
  • 今天qq提示我们在一起7年了 七年不长也不短当然我们还有很多个七年 说好不分离嗯说到做到 今天进老马空间看到吉在2...
    粉红路阅读 152评论 0 0